org.apache.jmeter.control

## Class RunTime

- java.lang.Object
- - org.apache.jmeter.testelement.AbstractTestElement
  - - org.apache.jmeter.control.GenericController
    - - org.apache.jmeter.control.RunTime

- All Implemented Interfaces:
    Serializable, Cloneable, Controller, Searchable, TestElement, TestCompilerHelper

      public class RunTime
      extends GenericController
      implements Serializable

  Runtime Controller that runs its children until configured Runtime(s) is exceeded
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.jmeter.control.GenericController

      `current, subControllersAndSamplers`

    - ### Fields inherited from interface org.apache.jmeter.testelement.TestElement

      `COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RunTime()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `getIterCount()`
    `long` | `getRuntime()`
    `String` | `getRuntimeString()`
    `protected void` | `incrementLoopCount()`
    `boolean` | `isDone()` Indicates whether the Controller is done delivering Samplers for the rest of the test.
    `Sampler` | `next()` Determines the next sampler to be processed.
    `protected Sampler` | `nextIsNull()` Called by `GenericController.next()` when `GenericController.getCurrentElement()` returns `null`.
    `protected void` | `reInitialize()` Resets the controller (called after execution of last child of controller): resetCurrent() (i.e.
    `protected void` | `resetLoopCount()`
    `void` | `setRuntime(long seconds)`
    `void` | `setRuntime(String seconds)`
    `void` | `triggerEndOfLoop()` Trigger end of loop condition on controller (used by Start Next Loop feature)

    - ### Methods inherited from class org.apache.jmeter.control.GenericController

      `addIterationListener, addTestElement, addTestElementOnce, currentReturnedNull, fireIterationStart, fireIterEvents, getCurrentElement, getSubControllers, incrementCurrent, incrementIterCount, initialize, initializeSubControllers, isFirst, nextIsAController, nextIsASampler, readResolve, removeCurrentElement, removeIterationListener, resetCurrent, resetIterCount, setCurrentElement, setDone, setFirst`

    - ### Methods inherited from class org.apache.jmeter.testelement.AbstractTestElement

      `addPropertiesValues, addProperty, addProperty, canRemove, clear, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.jmeter.testelement.TestElement

      `canRemove, clear, clearTestElementChildren, clone, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getThreadContext, getThreadName, isEnabled, isRunningVersion, isTemporary, propertyIterator, recoverRunningVersion, removed, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse`

- - ### Constructor Detail

    - #### RunTime

          public RunTime()

  - ### Method Detail

    - #### setRuntime

          public void setRuntime(long seconds)

    - #### setRuntime

          public void setRuntime(String seconds)

    - #### getRuntime

          public long getRuntime()

    - #### getRuntimeString

          public String getRuntimeString()

    - #### isDone

          public boolean isDone()

      Indicates whether the Controller is done delivering Samplers for the rest of the test. When the top-level controller returns true to JMeterThread, the thread is complete.
      Specified by:
        `isDone` in interface `Controller`
      Overrides:
        `isDone` in class `GenericController`
      Returns:
        boolean
      See Also:
        `Controller.isDone()`

    - #### next

          public Sampler next()

      Description copied from class: `GenericController`

      Determines the next sampler to be processed.

      If `GenericController.isDone()` is `true`, returns null.

      Gets the list element using current pointer. If this is `null`, calls `GenericController.nextIsNull()`.

      If the list element is a `Sampler`, calls `GenericController.nextIsASampler(Sampler)`, otherwise calls `GenericController.nextIsAController(Controller)`

      If any of the called methods throws `NextIsNullException`, returns `null`, otherwise the value obtained above is returned.

      Specified by:
        `next` in interface `Controller`
      Overrides:
        `next` in class `GenericController`
      Returns:
        the next sampler or `null`

    - #### nextIsNull

          protected Sampler nextIsNull()
                                throws NextIsNullException

      Called by `GenericController.next()` when `GenericController.getCurrentElement()` returns `null`. Reinitialises the controller.
      Overrides:
        `nextIsNull` in class `GenericController`
      Returns:
        null (always, for this class)
      Throws:
        `NextIsNullException` - when the end of the list has already been reached

    - #### incrementLoopCount

          protected void incrementLoopCount()

    - #### resetLoopCount

          protected void resetLoopCount()

    - #### getIterCount

          protected int getIterCount()

      Overrides:
        `getIterCount` in class `GenericController`

    - #### reInitialize

          protected void reInitialize()

      Description copied from class: `GenericController`
      Resets the controller (called after execution of last child of controller):
      - resetCurrent() (i.e. current=0)
      - increment iteration count
      - sets first=true
      - recoverRunningVersion() to set the controller back to the initial state
      Overrides:
        `reInitialize` in class `GenericController`

    - #### triggerEndOfLoop

          public void triggerEndOfLoop()

      Trigger end of loop condition on controller (used by Start Next Loop feature)
      Specified by:
        `triggerEndOfLoop` in interface `Controller`
      Overrides:
        `triggerEndOfLoop` in class `GenericController`

Copyright © 1998-2021 Apache Software Foundation. All Rights Reserved.